Description

Objective
Users can upload files. Files can be used as images for VMs, if they are in the gcow2 format.

How it works

e Files are uploaded to a specific VM (likely files.datacenterlight.ch)
e Users can use the ucloud-cli to convert a file to an image

CLI

¢ ucloud image-create-from-file --uuid $UUID --name <name-of-the-image> --image-store <name> [--desc "optional description"]
[--public]
o if --public is passed, the image is public
o do not implement --public before v2
o for --public we need to clarify how is paying for the storage
o Need to specify the name of the image store; OR we use the UUID (persisten!) of the image store
¢ ucloud image-set-permission [--public|--private]
o makes image public or private
o do not implement before v2

API

The APl modifies entries in etcd as follows:

¢ Finds the file in etcd
o if it does not exist -> error out
o Only accept "sane" filenames (i.e. no .. and funky stuff)
¢ Creates an image entry below /v1/image/$UUID
o maybe the same UUID as the file OR a random UUID - to be discussed in ucloud channel
o JSON: set status on create to "TO_BE_CREATED", needs to include "owner" field

Cron job on files.datacenterlight.ch

¢ Scans all entries in /v1/image
e |f there is a json with TO_BE_CREATED
o Look for the filename below basepath/$owner/$filename
o If it is not there, error out
¢ |fimage is found
o Verify that it is gcow2 format (file or gemu-img)
o Convert it to raw and import it into ceph
= gemu-img convert ... | rbd import ...

-> ping @IInu for a test ceph cluster to try this out

Related issues:
Related to Open Infrastructure - Task #6904: Implement ucloud-image-store man... Rejected 06/29/2019

History

#1 - 06/28/2019 08:16 PM - Ahmed Bilal

- Status changed from New to Seen

#2 - 06/29/2019 10:10 AM - Nico Schottelius

- Related to Task #6904: Implement ucloud-image-store management added

#3 - 06/29/2019 10:11 AM - Nico Schottelius
- Description updated

#4 - 07/02/2019 08:46 AM - Ahmed Bilal

Nico Schottelius wrote:

Objective

Users can upload files. Files can be used as images for VMs, if they are in the qcow?2 format.

How it works

e Files are uploaded to a specific VM (likely files.datacenterlight.ch)
e Users can use the ucloud-cli to convert a file to an image

CLI

¢ ucloud image-create-from-file --uuid $UUID --name <name-of-the-image> --image-store <name> [--desc "optional description"] [--public]
o if --public is passed, the image is public
o do not implement --public before v2
o for --public we need to clarify how is paying for the storage
o Need to specify the name of the image store; OR we use the UUID (persisten!) of the image store
e ucloud image-set-permission [--public|--private]
o makes image public or private
o do not implement before v2

API

The API modifies entries in etcd as follows:

¢ Finds the file in etcd
o if it does not exist -> error out
o Only accept "sane" filenames (i.e. no .. and funky stuff)
* Creates an image entry below /v1/image/$UUID
o maybe the same UUID as the file OR a random UUID - to be discussed in ucloud channel
o JSON: set status on create to "TO_BE_CREATED", needs to include "owner" field

Cron job on files.datacenterlight.ch

e Scans all entries in /vi/image
e [f there is a json with TO_BE_CREATED
o Look for the filename below basepath/$owner/$filename
o Ifitis not there, error out
¢ If image is found
o Verify that it is gcow?2 format (file or gemu-img)
o Convert it to raw and import it into ceph
= gemu-img convert ... | rbd import ...

-> ping @lInu for a test ceph cluster to try this out
Instead of image-create-from-file sub-command, the sub-command would be create-image-from-file

#5 - 07/03/2019 11:41 AM - Ahmed Bilal

- Status changed from Seen to In Progress

#6 - 07/03/2019 03:09 PM - Ahmed Bilal
- Status changed from In Progress to Feedback

#7 - 07/15/2019 04:32 PM - Ahmed Bilal

- Status changed from Feedback to In Progress

#8 - 12/01/2020 02:43 PM - Ahmed Bilal
- Assignee deleted (Ahmed Bilal)

#9 - 01/02/2024 02:03 PM - Nico Schottelius

- Status changed from In Progress to Rejected
